xfstests: Assume yes when test device is not partitioned
[xfstests-dev.git] / 247
1 #! /bin/bash
2 # FS QA Test No. 247
3 #
4 # Test for race between direct I/O and mmap
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2010 Red Hat, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #-----------------------------------------------------------------------
22 #
23 # creator
24 owner=lmcilroy@redhat.com
25
26 seq=`basename $0`
27 echo "QA output created by $seq"
28
29 here=`pwd`
30 tmp=/tmp/$$
31 status=1        # failure is the default!
32 trap "_cleanup; exit \$status" 0 1 2 3 7 15
33
34 _cleanup()
35 {
36     cd /
37     rm -f $tmp.* $testfile
38     wait
39 }
40
41 # get standard environment, filters and checks
42 . ./common.rc
43 . ./common.filter
44
45 # real QA test starts here
46
47 # Modify as appropriate.
48 _supported_fs generic
49 _supported_os Linux
50
51 testfile=$TEST_DIR/$seq.$$
52
53 loops=500
54 iosize=1048576
55
56 # Initialise file
57 dd if=/dev/zero of=$testfile bs=$iosize count=$loops &> /dev/null
58 [ $? -ne 0 ] && exit
59 sync
60         
61 # Direct I/O overwriter
62 dd if=/dev/zero of=$testfile oflag=direct bs=$iosize count=$loops conv=notrunc &> /dev/null &
63 [ $? -ne 0 ] && exit
64
65 # Mmap writer
66 start=`expr $loops - 1`
67 for i in `seq $start -1 0`
68 do
69         offset=`expr $i \* $iosize`
70         $XFS_IO_PROG -F -f -c "mmap -w $offset $iosize" -c "mwrite $offset $iosize" $testfile
71         [ $? -ne 0 ] && exit
72 done
73
74 wait
75
76 echo "Silence is golden."
77
78 # success, all done
79 status=0
80 exit